use XML::Parser;

die "No filenames supplied" unless @ARGV > 0;

my $p = new XML::Parser(Handlers => {Char  => \&chardata,
				     Final => \&final
				    });

foreach (@ARGV) {
  my $totsize = -s $_;
  my $txtsize = $p->parsefile($_);
  my $density = int(($totsize - $txtsize)*100/$totsize );

  print "$_\t$density%\n";
}

################
## End main
################

sub chardata {
  my ($xp, $data) = @_;

  $xp->{Charcount} += length($data);
}

sub final {
  my ($xp) = @_;

  return $xp->{Charcount};
}

